.\"
.
.
.
.TH Grind: '' '2013-02-02'
.
.
.
.SH NAME
.PP
\fBgrind\fR - troff preprocessor which highlight source code
.
.
.
.SH SYNOPSIS
.PP
\fB#{BINDIR}/grind\fR
[\fB-d \fIfile\fR]
[\fB-h \fIheader\fR]
[\fB-l \fIlanguage\fR]
[\fB-t \fIsize\fR]
\fIname\fR ...
.
.
.
.SH DESCRIPTION
.PP
\fIGrind\fR insert string definition in files to
highlight the source code they contain. \fIGrind\fR runs in
two basic modes: regular mode or whole file mode.
.IP \(bu
In regular mode, \fIgrind\fR only highlight code which is
between the \fBvS\fR and \fBvE\fR macros. The language is
specified by the first argument of the \fBvs\fR macro.
.IP \(bu
In whole file mode, grind highlight the whole file. The
language is specified by the \fB-l\fR argument.
.PP
The options are:
.TP
\fB-d\fR
Specifies an alternate language definitions file (default is
#{LIBDIR}/grindefs).
.TP
\fB-h\fR
Specify a header string. The header will be printed as
argument of the \fB.vH\fR macro.
.TP
\fB-l\fR
Enter whole file mode, and pecifies the language to use.
.TP
\fB-t\fR
Specify a nondefault tab size (default is 4).
.PP
Currently, known languages are
C (\fB-lc\fR),
C++ (\fB-lc++\fR),
CSH (\fB-lcsh\fR),
FORTRAN (\fB-lfortran\fR),
ICON (\fB-lI\fR,)
ISP (\fB-lisp\fR),
LDL (\fB-ldl\fR),
LISP LIKE (\fB-ml\fR),
MODEL (\fB-lm\fR),
MODULA2 (\fB-lmod2\fR),
PASCAL (\fB-lp\fR),
RATFOR (\fB-lr\fR),
RUSSEL (\fBrussell\fR),
SHELL (\fB-lsh\fR),
TROFF (\fB-ltr\fR),
and
YACC (\fB-lyacc\fR),
.
.
.
.SH PROGRAMMING STYLE
.PP
\fIGrind\fP assumes that a certain programming style is
followed:
.TP
C and C++
Functions names can be preceded on a line only by spaces,
tabs, or an asterisk. The parenthesized arguments must also
be on the same line.
.TP
PASCAL
Function names need to appear on the same line as the
keywords \fIfuctions\fR or \fIprocedure\fR.
.TP
MODEL
Function names need to appear on the same line as the keywords
\fIis beginproc\fR.
.TP
TROFF
Between \fB.vS\fR and \fB.vE\fR macros in regular mode, and
in the whole file in whole file mode, \fIGrind\fR will take
care to escape all the commands, macros, strings and number
register that could be interpreted by troff. That means that
to highlight troff source code, one juste has to write the
code as is. That also means that it is not possible to
insert formatting commands inside the code that has to be
highlighted.
.PP
More generally, arbitrary formatting styles for programs
mostly look bad. The use of spaces to align source code
fails miserably; if you plan to \fIgrind\fR your program you
should use tabs. This is somewhat inevitable since the font
used by \fIgrind\fR is variable width.
.
.
.
.SH MACROS AND STRINGS
.PP
To highlight code, \fIGrind\fR insert strings in the file,
and use some macros, so, to format the output of \fIgrind\fR
with \fItroff\fR, the following strings and macros must be
defined by your macro file.
.
.
.
.SS MACROS
.RS 3
.TP
vS
In regular mode, start a code block to highlight. The first
argument define the language. See the \fB-l\fR option to
get the list of supported languages.
.TP
vE
In regular mode, end a code block to highlight.
.TP
vF
In whole file mode, start a new file. The first argument is the
name of the file.
.TP
vH
The header defined by the \fB-h\fR option is defined as
argument of this macro.
.TP
vO
Indicate that a function begins on the next line. The first
argument is the function name.
.TP
vC
Indicate that a function gets closed on the previous line.
.
.
.
.SS STRINGS
.RS 3
.TP
+C
Begin a comment,
.TP
-C
End a comment,
.TP
+K
Begin a keyword,
.TP
-K
End a keyword,
.TP
+S
Begin a string,
.TP
-S
End a string,
.TP
+V
Begin a variable,
.TP
-V
End a variable,
.TP
e
a slash (\),
.TP
-
a tiret (-),
.TP
_
a bottom tiret (_).
.
.
.
.SH HISTORY
.PP
\fIGrind\fR is a hack of \fIvfontedpr\fR (that probably
means
\fIvisual-font-edit-print\fR), which is the preprocesor used by
the mostly forgotten \fIvgrind\fR script, which aims to
visually "grind nice listing of programms" with troff. The
code that vfontedpr use to read the language description
file is "stolen almost totally from \fItermcap\fR".
\fIVgrind\fP and \fIvfontedpr\fR have been written by Dave
Presotto and William Joy, for 4.3BSD-Tahoe. They have been
modified by Gunnar Ritter as part of the \fIHeirloom
documentation tools\fR.
.
.
.
.SH LICENSE
.PP
\fIGrind\fR and its man page are distributed under the
original BSD license. The language description file
(\fI#{LIBDIR}/grindefs\fR) is distributed under the CDDL 1.0
License.
.
.
.
.SH FILES
.PP
\fI#{BINDIR}/grind\fR preprocessor
\fI#{LIBDIR}/grindefs\fR language descriptions
.
.
.
.SH SEE ALSO
troff(1B)
.
.
.
.SH AUTHORS
.PP
Written by Dave Presotto and William Joy. Modified by Gunnar
Ritter and Pierre-Jean Fichet.
